using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class mikesound : MonoBehaviour
{
    int objno = 0;
    rtcmixmain RTcmix;
    private bool did_start = false;


    private void Awake()
    {
        // find the RTcmixmain object with the RTcmix function definitions
        RTcmix = GameObject.Find("RTcmixmain").GetComponent<rtcmixmain>();
    }


    // Use this for initialization
    void Start()
    {
        // this sets up for real-time mic input
        AudioSource audioSource = GetComponent<AudioSource>();
        audioSource.clip = Microphone.Start(null, true, 1, 44100);
        audioSource.loop = true;
        while (!(Microphone.GetPosition(null) > 0)) { }

        audioSource.Play();


        // initialize RTcmix
        RTcmix.initRTcmix(objno);

        // send a note using the WAVETABLE() instrument
        RTcmix.SendScore("rtinput(\"AUDIO\")", objno);
        RTcmix.SendScore("PANECHO(0, 0, 9999, 1, 0.2, 0.35, 0.7, 1)", objno);

        did_start = true;
    }


    // Update is called once per frame
    void Update()
    {
    }


    void OnAudioFilterRead(float[] data, int channels)
    {
        if (!did_start) return;

        // compute sound samples
        RTcmix.runRTcmix(data, objno, 1); // "1" to set up input processing of sound
    } 


    void OnApplicationQuit()
    {
        did_start = false;
        RTcmix = null;
    }
}
